/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ije.exam2;

import java.util.Calendar;
import java.util.HashSet;
import java.util.Set;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author coki
 * Implement the small application for the theatre. Implement classes Theatre, Performance, and Author. 
 * These classes represent theatre, performance, and author of the performance. The performance is 
 * held in the theatre. Each performance stores information about its name (title), author, and
 * the date of this performance. Implement all required methods and constructors in accordance 
 * with following test methods (test01, test02, test03).
 */
public class TheatreTest {

    @Test // 7 point
    public void test01() {
        Set<Author> as = new HashSet<Author>();
        Author a1 = new Author("Author1");
        Author a2 = new Author("Author2");
        as.add(a1);
        as.add(a2);
        assertTrue(as.contains(new Author("Author1")));
    }
    
    @Test // 15 points
    public void test02() {
        // it creates a new theatre with 10 lines of seats, 20 seats in each line
        Theatre t = new Theatre(10, 20);
        Author a = new Author("Author1");

        Calendar d1 = Calendar.getInstance();
        d1.set(2009, 2, 26);
        // it creates a new performance of author a and title "Title1" held on the date d1
        Performance p1 = new Performance(d1, a, "Title1");

        Calendar d2 = Calendar.getInstance();
        d2.set(2009, 2, 28);
        Performance p2 = new Performance(d2, a, "Title2");
        
        // it adds performances to the theatre
        assertTrue(t.addPerformance(p1));
        assertTrue(t.addPerformance(p2));
        
        // it is impossible to add another performance on the same date
        assertFalse(t.addPerformance(p2));

        // what performance is in the plan on the specified date?
        assertEquals(p1, t.performanceOnDate(d1));
        // what performance is in the plan on the specified date? if none, it returns null
        assertNull(t.performanceOnDate(Calendar.getInstance()));
    }

    @Test // 15 points
    public void test03() {
        Theatre t = new Theatre(10, 20);
        Author a = new Author("Author1");
        Author a2 = new Author("Author2");

        Calendar d1 = Calendar.getInstance();
        d1.set(2009, 2, 26);
        Performance p1 = new Performance(d1, a, "Title1");

        Calendar d2 = Calendar.getInstance();
        d2.set(2009, 2, 28);
        Performance p2 = new Performance(d2, a, "Title2");

        Calendar d3 = Calendar.getInstance();
        d2.set(2009, 3, 28);
        Performance p3 = new Performance(d3, a2, "Title3");
        
        assertTrue(t.addPerformance(p1));
        assertTrue(t.addPerformance(p2));
        assertTrue(t.addPerformance(p3));
        
        // what performances are created by the given author?
        Set<Performance> pa = t.performancesOfAuthor(new Author("Author1"));
        assertEquals(pa.size(), 2);
        assertTrue(pa.contains(p2));        
        assertFalse(pa.contains(d3));        
    }
    
    public TheatreTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
    }

    @After
    public void tearDown() {
    }
    

    

}